(* Embedding of FOL *)
open Common

type t = Leq of term * term
       | Eq of term * term
       | Not of t
       | Or of t * t
       | And of t * t
       | Forall of (var -> t)

val implies : t -> t -> t

val subst : var -> term -> t -> t

val check : t -> Common.result
